-- ͻ
--        D E S I G N   E N G I N E R I N G              DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         Package     Os2.Jba                                        
--                                                                    
--         Author :  Leonid Dulman     1996 , 1997                    
--                                                                    
--              GNU ADA RUNTIME LIBRARY (GNARL) COMPONENTS            
--                                                                    
--              Interface to Visual Developer JBA International       
--                                                                    
-- ͼ

with System;
with os2.pmwb; use os2.pmwb;
with os2.pmwd; use os2.pmwd;
with os2.pmhp; use os2.pmhp ;
with os2.gpi ; use os2.gpi ;
with os2.bse ; use os2.bse ;
with Interfaces.C ;
with Interfaces.C.Strings ;
package Os2.Jba is
-- pragma preelaborate(Jba);
Type P_WndProc is access function (hw : HWND ;  msg: ULONG ;
                               mp1 : PMPARAM ; mp2 : PMPARAM) return Ulong ;
Subtype string_256 is string(1..256); -- ccmaxpathcomp
Subtype string_21  is string(1..21 );
Subtype PMENTRY    is Ulong ;

--  Conversion from/to GuiStr;

SubType GuiStr is Interfaces.C.Strings.chars_ptr ;

function To_guiStr(str:string) return GuiStr renames
         Interfaces.C.Strings.New_String;

function From_guiStr(guistring:GuiStr) return string renames
         Interfaces.C.Strings.Value ;

function From_guiStr(guistring:GuiStr; Len:Interfaces.C.size_t) return string renames
         Interfaces.C.Strings.Value ;

 -- Interface struc to Window Procedure
type HWULMPMP is record
hw : HWND    ;
ul : ULONG   ;
mp1: PMPARAM  ;
mp2: PMPARAM  ;
end record ;

type HWULMPPV is record
hw : HWND    ;
ul : ULONG   ;
mp : PMPARAM  ;
pv : PVOID   ;
end record ;

 WM_GUIDATAINDEX      : constant Ulong := WM_USER+1 ;   -- Get window words index
 WM_GUIGETWINDOW      : constant Ulong := WM_USER+2 ;   -- Get window information
 WM_GUIGETPROPERTY    : constant Ulong := WM_USER+3 ;   -- Get window property
 WM_GUISETPROPERTY    : constant Ulong := WM_USER+4 ;   -- Set window property
 WM_GUIWINDOWLOADED   : constant Ulong := WM_USER+5 ;   -- Window has been loaded
 WM_GUIPARENTRESIZED  : constant Ulong := WM_USER+6 ;   -- Parent has resized
 WM_GUITHREADENDED    : constant Ulong := WM_USER+7 ;   -- Thread ended
 WM_GUISHUTDOWN       : constant Ulong := WM_USER+8 ;   -- Shutdown detected
 WM_GUISETHELPFILE    : constant Ulong := WM_USER+9 ;
 WM_GUIUSER           : constant Ulong := WM_USER+10;    -- Last GUI message
 WM_SETFOCUSMLE       : constant Ulong := WM_USER+100;   -- Message to set the focus
                                                         -- to MLE

-- subtype PMENTRY is PVOID; --  MRESULT APIENTRY

 IDHT_GUIMAIN   :constant Ulong := 4000 ; -- Main help table ID

 IDD_GUIUNKNOWN :constant Ulong :=  9999; -- Missing resource

--    Window word offsets for mandatory values.                            *

 QWS_ORIGXPOS    :constant Ulong :=     0 ;    -- Unscaled X position
 QWS_ORIGYPOS    :constant Ulong :=     2 ;    -- Unscaled Y position
 QWS_ORIGWIDTH   :constant Ulong :=     4 ;    -- Unscaled width
 QWS_ORIGHEIGHT  :constant Ulong :=     6 ;    -- Unscaled height
 QWL_MOUSEIMG    :constant Ulong :=     8 ;    -- Mouse pointer type
 QWL_MOUSEPTR    :constant Ulong :=     12;    -- Mouse pointer handle
 QWL_GUIUSER     :constant Ulong :=     16;    -- Start of user words

--    System window/control class constants.                               *

 WC_GUIBUTTON     :constant string :="GUIBUTTON"      ;
 WC_GUICOMBOBOX   :constant string :="GUICOMBOBOX"    ;
 WC_GUIENTRYFIELD :constant string :="GUIENTRYFIELD"  ;
 WC_GUILISTBOX    :constant string :="GUILISTBOX"     ;
 WC_GUIMLE        :constant string :="GUIMLE"         ;
 WC_GUISCROLLBAR  :constant string :="GUISCROLLBAR"   ;
 WC_GUISTATIC     :constant string :="GUISTATIC"      ;

--   Standard window/control names.                                        *

 WT_UNKNOWN       :constant string := "Unknown" & character'val(0) ;
 WT_DESKTOP       :constant string := "Desktop" & character'val(0) ;
 WT_OBJECT        :constant string := "Object"  & character'val(0);
 WT_FRAME         :constant string := "Frame"  & character'val(0);
 WT_DIALOG        :constant string := "Dialog" & character'val(0) ;
 WT_CLIENT        :constant string := "Client" & character'val(0) ;
 WT_SYSMENU       :constant string := "System Menu" & character'val(0) ;
 WT_MENUBAR       :constant string := "Menu Bar" & character'val(0) ;
 WT_SUBMENU       :constant string := "Sub Menu" & character'val(0) ;
 WT_MENUITEM      :constant string := "Menu Item" & character'val(0) ;
 WT_PUSHBUTTON    :constant string := "Push Button" & character'val(0) ;
 WT_RADIOBUTTON   :constant string := "Radio Button" & character'val(0) ;
 WT_CHECKBOX      :constant string := "Checkbox" & character'val(0) ;
 WT_3STATE        :constant string := "3-State Checkbox" & character'val(0) ;
 WT_USERBUTTON    :constant string := "User Button" & character'val(0) ;
 WT_COMBOBOX      :constant string := "Combobox" & character'val(0) ;
 WT_ENTRYFIELD    :constant string := "Entry Field" & character'val(0) ;
 WT_LISTBOX       :constant string := "Listbox" & character'val(0) ;
 WT_MLE           :constant string := "Multi-Line Entry" & character'val(0) ;
 WT_VSCROLL       :constant string := "Vert. Scrollbar" & character'val(0) ;
 WT_HSCROLL       :constant string := "Horz. Scrollbar" & character'val(0) ;
 WT_STATICTEXT    :constant string := "Static Text" & character'val(0) ;
 WT_GROUPBOX      :constant string := "Group Box" & character'val(0) ;
 WT_STATICICON    :constant string := "Icon" & character'val(0) ;
 WT_STATICSYSICON :constant string := "System Icon" & character'val(0) ;
 WT_STATICBITMAP  :constant string := "Bitmap" & character'val(0) ;
 WT_STATICRECT    :constant string := "Rectangle" & character'val(0) ;
 WT_CUSTOM        :constant string := "Custom Control" & character'val(0) ;

--    System window/control property identifiers.                          *

 WPID_NAME     : constant  long:= 0 ; -- Window name
 WPID_ID       : constant  long:= 1 ; -- Window ID
 WPID_PARENT   : constant  long:= 2 ; -- Window parent
 WPID_OWNER    : constant  long:= 3 ; -- Window owner
 WPID_XPOS     : constant  long:= 4 ; -- Window X position
 WPID_YPOS     : constant  long:= 5 ; -- Window Y position
 WPID_WIDTH    : constant  long:= 6 ; -- Window width
 WPID_HEIGHT   : constant  long:= 7 ; -- Window height
 WPID_STYLE    : constant  long:= 8 ; -- Window style flags
 WPID_HELP     : constant  long:= 9 ; -- Window help name
 WPID_TEXT     : constant  long:=10 ; -- Window text
 WPID_VISIBLE  : constant  long:=11 ; -- Window visible?
 WPID_ENABLED  : constant  long:=12 ; -- Window enabled?
 WPID_UPDATE   : constant  long:=13 ; -- Window update enabled?
 WPID_MOUSEPTR : constant  long:=14 ; -- Window mouse pointer
 WPID_USER     : constant  long:=15 ; -- Last system property

--    Property indexes for some of the system controls.                    *

 WPID_FRAMEFLAGS      : constant  long:=WPID_USER+0 ; -- Frame flags
 WPID_FRAMEMEMOPTIONS : constant  long:=WPID_USER+1 ; -- Frame memory options
 WPID_FRAMEICON       : constant  long:=WPID_USER+2 ; -- Frame icon name
 WPID_FRAMESOURCE     : constant  long:=WPID_USER+3 ; -- Frame source file

 WPID_BUTTONCHECKED   : constant  long:=WPID_USER+0 ; -- Button checked
 WPID_BUTTONRESOURCE  : constant  long:=WPID_USER+1 ; -- Button resource name
 WPID_BUTTONDEFAULT   : constant  long:=WPID_USER+2 ; -- Button default
 WPID_BUTTONALIAS     : constant  long:=WPID_USER+3 ; -- Button alias

 WPID_CUSTOMCLASS     : constant  long:=WPID_USER+0 ; -- Custom class name

 WPID_ENTRYMAXLENGTH  : constant  long:=WPID_USER+0 ; -- Entry field max length
 WPID_ENTRYMINSEL     : constant  long:=WPID_USER+1 ; -- Entry field min sel.
 WPID_ENTRYMAXSEL     : constant  long:=WPID_USER+2 ; -- Entry field max sel.

 WPID_LISTBOXCOUNT    : constant  long:=WPID_USER+0 ; -- Listbox count
 WPID_LISTBOXSEL      : constant  long:=WPID_USER+1 ; -- Listbox selection
 WPID_LISTBOXTOP      : constant  long:=WPID_USER+2 ; -- Listbox top

 WPID_MENUFLAGS       : constant  long:=WPID_USER+0 ; -- Menu flags
 WPID_MENUPOSITION    : constant  long:=WPID_USER+1 ; -- Menu position
 WPID_MENUBITMAP      : constant  long:=WPID_USER+2 ; -- Menu bitmap
 WPID_MENUACCELFLAGS  : constant  long:=WPID_USER+3 ; -- Menu accel flags
 WPID_MENUACCELKEY    : constant  long:=WPID_USER+4 ; -- Menu accel key
 WPID_MENUCHECKED     : constant  long:=WPID_USER+5 ; -- Menu checked

 WPID_SCROLLMIN       : constant  long:=WPID_USER+0 ; -- Scrollbar minimum
 WPID_SCROLLMAX       : constant  long:=WPID_USER+1 ; -- Scrollbar maximum
 WPID_SCROLLPOS       : constant  long:=WPID_USER+2 ; -- Scrollbar position

 WPID_STATICRESOURCE  : constant  long:=WPID_USER+0 ; -- Static resource name

--   Data type constants.                                                  *

 DT_VOID       : constant Ulong:=  16#00000000#;   -- Void         (no type)
 DT_SHORT      : constant Ulong:=  16#00000001#;   -- Short          (short)
 DT_LONG       : constant Ulong:=  16#00000002#;   -- Long            (long)
 DT_INT        : constant Ulong:=  16#00000003#;   -- int    (Short or Long)
 DT_SREAL      : constant Ulong:=  16#00000004#;   -- Short Real     (float)
 DT_REAL       : constant Ulong:=  16#00000008#;   -- Real          (double)
 DT_LREAL      : constant Ulong:=  16#00000010#;   -- Long Real(long double)
 DT_SCALED     : constant Ulong:=  16#00000020#;   -- Scaled integer (zoned)
 DT_NUM        : constant Ulong:=  16#000000FF#;   -- Numeric type
 DT_STRING     : constant Ulong:=  16#00000100#;   -- String string (char *)
 DT_WINDOW     : constant Ulong:=  16#00000200#;   -- Window information
 DT_IMAGE      : constant Ulong:=  16#00000400#;   -- Image type
 DT_MESSAGE    : constant Ulong:=  16#00000800#;   -- Message type
 DT_CHAR       : constant Ulong:=  16#00001000#;   -- Character type
 DT_CLASS      : constant Ulong:=  16#00004000#;   -- Class type
 DT_USER       : constant Ulong:=  16#00008000#;   -- User data type
 DT_THREAD     : constant Ulong:=  16#00010000#;   -- Thread information
 DT_MODULE     : constant Ulong:=  16#00020000#;   -- Module routine address
 DT_STRUCT     : constant Ulong:=  16#00040000#;   -- Structure
 DT_ANYSTRUCT  : constant Ulong:=  16#00080000#;   -- Any structure
 DT_ANY        : constant Ulong:=  16#000FFFFF#;   -- Any type

--    Miscellaneous types.                                                 *
subtype REAL  is float;
subtype SREAL is float;
subtype double is Long_float;
subtype LREAL  is Long_float;
subtype PFNVOID is PVOID;
subtype PFNMOD  is PVOID;
subtype HPOINTER is PVOID;
-- typedef float       SREAL, *PSREAL;
-- typedef double      REAL,  *PREAL;
-- typedef long double LREAL, *PLREAL;
-- typedef void (_PFNVOID) (void);
-- typedef _PFNVOID *PFNVOID;

--    Window data type.                                                    *

Type WINDOW is record
szType       : string_21 :=(others=>character'val(0)); -- Window type
lID          : LONG      := 0    ;                     -- Window ID
h_wnd        : HWND      := 0    ;                     -- Window handle
hwndClient   : HWND      := 0    ;                     -- Window client
hwndParent   : HWND      := 0    ;                     -- Window parent
p_fnwp       : Pvoid     := System.Null_Address    ;   -- Window procedure
h_Module     : HMODULE   := 0    ;                     -- Resource module
end record ;
Type PWINDOW is access all WINDOW ;

MainWindow   : aliased WINDOW ;  -- main window

type PWSHST is record
pw : PWINDOW ;
sh : SHORT   ;
st : string(1..256) ;
end record ;
type PPWSHST is access all PWSHST ;


--    Message data type.                                                   *

Type    MESSAGE is record
lMsgID    :       LONG  ;  -- Message ID
ulOptions :       ULONG ;  -- Message display options
end record;
Type PMESSAGE is access all MESSAGE;

--    Message box return codes.                                            *

 GUIMBID_OK     : constant Ulong :=  MBID_OK ;
 GUIMBID_CANCEL : constant Ulong :=  MBID_CANCEL ;
 GUIMBID_ABORT  : constant Ulong :=  MBID_ABORT ;
 GUIMBID_RETRY  : constant Ulong :=  MBID_RETRY ;
 GUIMBID_IGNORE : constant Ulong :=  MBID_IGNORE ;
 GUIMBID_YES    : constant Ulong :=  MBID_YES ;
 GUIMBID_NO     : constant Ulong :=  MBID_NO ;
 GUIMBID_ENTER  : constant Ulong :=  MBID_ENTER ;
 GUIMBID_HELP   : constant Ulong :=  MBID_HELP ;

--**************************************************************************
--    The Scaled class provides support for the JOT scaled integer         *
--    data type. It provides support for arbitrary precision numbers.      *
--*************************************************************************

type Scaled is record  -- Internal representation variables.
lSign  : long  ;  -- Sign of number
lTotal : long  ;  -- Total number of digits
lDec   : long  ;  -- Total number of decimals
lAlloc : long  ;  -- Total size allocated
pDigits: pchar ;  -- Digits array
end record ;

--**************************************************************************
--    Macro for defining encoded ZONED fields within structures.           *
--*************************************************************************

-- #define SCALED(name,len,dec) char name[len]

--**************************************************************************
--   The Image class provides support for the JOT IMAGE data type.        *
-- **************************************************************************

-- class ImageRef ;    // Invisible implementation of images

type Image is  record --  `Properties' of the image class
Type_Image  : ULONG  ;
Handle_Image: LHANDLE;
end record;
type PImage is access all Image;

function GuiMakeImage (p1:ULONG; p2:long; p3:HMODULE) return  ULONG ;
pragma Import(c,GuiMakeImage, Link_name=>"_GuiMakeImage");

procedure GuiFreeImage (p:PImage) ;
pragma Import(c,GuiFreeImage, Link_name=>"_GuiFreeImage");

function  GuiCopyIcon  (hp:HPOINTER) return ULONG ;
pragma Import(c,GuiCopyIcon, Link_name=>"_GuiCopyIcon__FUI");

function  GuiCopyBitmap(hb:HBITMAP)  return ULONG ;
pragma Import(c,GuiCopyBitmap, Link_name=>"_GuiCopyBitmap__FUI");

--    Image types.                                                         *

 GUIIMG_UNKNOWN    :constant Ulong:=  0 ;  -- Unknown image type
 GUIIMG_ICON       :constant Ulong:=  1 ;  -- Icon image
 GUIIMG_POINTER    :constant Ulong:=  2 ;  -- Pointer image
 GUIIMG_BITMAP     :constant Ulong:=  3 ;  -- Bitmap image
 GUIIMG_SYSICON    :constant Ulong:=  4 ;  -- System icon image
 GUIIMG_SYSPOINTER :constant Ulong:=  5 ;  -- System pointer image
 GUIIMG_SYSBITMAP  :constant Ulong:=  6 ;  -- System bitmap image
 GUIIMG_METAFILE   :constant Ulong:=  7 ;  -- Metafile image

 --   Image drawing flags.                                                 *

 GUIDRW_NORMAL    :constant Ulong:= 16#00000000# ; -- Draw normal
 GUIDRW_HALFTONED :constant Ulong:= 16#00000001# ; -- Draw half-toned
 GUIDRW_INVERTED  :constant Ulong:= 16#00000002# ; -- Draw inverted
 GUIDRW_STRETCHED :constant Ulong:= 16#00000004# ; -- Draw stretched

procedure GuiDrawImageFromFile(pw:pwindow;          -- window
                               x,y:long;            -- x,y coordinats
                               file_name:string;    -- full file name
                               drw : ulong := GUIDRW_NORMAL ) ;

function GuiSetImageFromFile(File_Name :string) return Image ;          -- file
--    Line types.                                                          *

 GUILINE_DOT           :constant Long:=  LINETYPE_DOT ;
 GUILINE_SHORTDASH     :constant Long:=  LINETYPE_SHORTDASH ;
 GUILINE_DASHDOT       :constant Long:=  LINETYPE_DASHDOT ;
 GUILINE_DOUBLEDOT     :constant Long:=  LINETYPE_DOUBLEDOT ;
 GUILINE_LONGDASH      :constant Long:=  LINETYPE_LONGDASH  ;
 GUILINE_DASHDOUBLEDOT :constant Long:= LINETYPE_DASHDOUBLEDOT ;
 GUILINE_SOLID         :constant Long:= LINETYPE_SOLID ;
 GUILINE_INVISIBLE     :constant Long:= LINETYPE_INVISIBLE ;

 GUIFILL_DENSE1      :constant Long:=  PATSYM_DENSE1;
 GUIFILL_DENSE2      :constant Long:=  PATSYM_DENSE2;
 GUIFILL_DENSE3      :constant Long:=  PATSYM_DENSE3;
 GUIFILL_DENSE4      :constant Long:=  PATSYM_DENSE4;
 GUIFILL_DENSE5      :constant Long:=  PATSYM_DENSE5;
 GUIFILL_DENSE6      :constant Long:=  PATSYM_DENSE6;
 GUIFILL_DENSE7      :constant Long:=  PATSYM_DENSE7;
 GUIFILL_DENSE8      :constant Long:=  PATSYM_DENSE8;
 GUIFILL_VERT        :constant Long:=  PATSYM_VERT ;
 GUIFILL_HORIZ       :constant Long:=  PATSYM_HORIZ;
 GUIFILL_DIAG1       :constant Long:=  PATSYM_DIAG1;
 GUIFILL_DIAG2       :constant Long:=  PATSYM_DIAG2;
 GUIFILL_DIAG3       :constant Long:=  PATSYM_DIAG3;
 GUIFILL_DIAG4       :constant Long:=  PATSYM_DIAG4;
 GUIFILL_NOSHADE     :constant Long:=  PATSYM_NOSHADE ;
 GUIFILL_SOLID       :constant Long:=  PATSYM_SOLID ;
 GUIFILL_HALFTONE    :constant Long:=  PATSYM_HALFTONE ;
 GUIFILL_HATCH       :constant Long:=  PATSYM_HATCH ;
 GUIFILL_DIAGHATCH   :constant Long:=  PATSYM_DIAGHATCH ;

--    RunProgram types.                                                    *

 GUIRUN_SYNC       :constant ushort:= EXEC_SYNC ;
 GUIRUN_ASYNC      :constant ushort:= EXEC_ASYNCRESULT ;
 GUIRUN_BACKGROUND :constant ushort:= EXEC_BACKGROUND ;

--    Code module data type.                                               *

-- typedef void (_PFNMOD)(void);
-- typedef _PFNMOD *PFNMOD;

--        //
--        //      `Properties' of the thread class
--        //
--        TID ID () const ;
--        HAB Anchor() const ;
--        HMQ MsgQueue() const ;

subtype Thread is pvoid;

function GuiCreateThread (p1:PFNMOD; p2:long; p3:PWINDOW) return Thread ;

--    Symbol pointer.                                                      *
subtype PSYM is PVOID ;

--    Application information.                                             *

type APPINFO is record
 h_ab         : HAB     ;  -- Main anchor block
 h_mq         : HMQ     ;  -- Main message queue
 p_id         : PID     ;  -- Current process ID
 CmdArgC      : integer ;  -- Command line count
 CmdArgV      : pchar   ;  -- Command line args
 hwndHelp     : HWND    ;  -- Help window
 hwndMain     : HWND    ;  -- Main window
 hwndSave     : HWND    ;  -- Saved focus window
 szPgmTitle   : string_256 :=(others => character'val(0)) ;  -- Task-list title
 szMsgFile    : string_256 :=(others => character'val(0)) ;  -- Message filename
 szCurMsgFile : string_256 :=(others => character'val(0)) ;  -- Current message file
 szHlpFile    : string_256 :=(others => character'val(0)) ;  -- Help filename
 szCurHlpFile : string_256 :=(others => character'val(0)) ;  -- Current help file
 szNxtHlpFile : string_256 :=(others => character'val(0)) ;  -- Next help file
 hmodNxtHelp  : HMODULE ;  -- Next help module
 sExitCode    : SHORT   ;  -- Program exit code
end record;
Type PAPPINFO is access all APPINFO ;

pApp   : PAPPINFO;  -- common appinfo access

--    DLL instance information.                                            *

type DLLINST is record
h_Module   :HMODULE       ; -- DLL module handle
szMsgFile  :string(1..256); -- DLL message file
szHlpFile  :string(1..256); -- DLL help file
end record;
type  PDLLINST is access all DLLINST;

--    Frame data (not stored in window words like other controls).         *

type FRAMEWORDS is  record
 p_fnwp    : PFNWP      ;  -- Frame window procedure
 lID       : LONG       ;  -- Frame window ID
 swpOrig   : SWP        ;  -- Unscaled frame size
 pMousePtr : PImage     ;  -- Mouse pointer image
end record ;
type   PFRAMEWORDS is access all FRAMEWORDS ;

--    Runtime error codes.                                                 *

 GUIERR_OK           :constant Ushort:= 0 ;         -- No error
 GUIERR_OUTOFMEMORY  :constant Ushort:=  00000001 ; -- Out of memory
 GUIERR_DIVBYZERO    :constant Ushort:=  00000002 ; -- Divide by zero
 GUIERR_CANTLOADWIN  :constant Ushort:=  00000003 ; -- Cant load window
 GUIERR_NULLHWND     :constant Ushort:=  00000004 ; -- Window does not exist
 GUIERR_EVENTLOOP    :constant Ushort:=  00000005 ; -- Event loop overflow
 GUIERR_THDSTARTED   :constant Ushort:=  00000006 ; -- Thread already started
 GUIERR_THDENDED     :constant Ushort:=  00000007 ; -- Thread already ended
 GUIERR_THDRUNNING   :constant Ushort:=  00000008 ; -- Thread still running
 GUIERR_MAX          :constant Ushort:=  00000008 ; -- Max. error number

--    RGB Colors.                                                          *

-- #define MAKERGB(r,g,b)      ((((ULONG)(r) & 16#FF) << 16) | \
--                              (((ULONG)(g) & 16#FF) << 8)  | \
--                              (((ULONG)(b) & 16#FF)))
--
 RGB_DARKGRAY :constant Long :=  CLR_DARKGRAY ; -- MAKERGB(128, 128, 128)
 RGB_DARKBLUE :constant Long :=  CLR_DARKBLUE ; -- MAKERGB(  0,   0, 128)
 RGB_DARKRED  :constant Long :=  CLR_DARKRED  ; -- MAKERGB(128,   0,   0)
 RGB_DARKPINK :constant Long :=  CLR_DARKPINK ; -- MAKERGB(128,   0, 128)
 RGB_DARKGREEN:constant Long :=  CLR_DARKGREEN; -- MAKERGB(  0, 128,   0)
 RGB_DARKCYAN :constant Long :=  CLR_DARKCYAN ; -- MAKERGB(  0, 128, 128)
 RGB_BROWN    :constant Long :=  CLR_BROWN    ; -- MAKERGB(128, 128,   0)
 RGB_PALEGRAY :constant Long :=  CLR_PALEGRAY ; -- MAKERGB(204, 204, 204)

function GuiSetUp(nm:guistr) return PAPPINFO ;
pragma Import(c,GuiSetUp, Link_name=>"_GuiSetUp__FPc");

function GuiAppInfo return PAPPINFO ;
pragma Import(c,GuiAppInfo, Link_name=>"_GuiAppInfo__Fv");

procedure GuiInitApp  (p1 :string; p2: string);

procedure   GuiExitApp  (p:SHORT);
pragma Import(c,GuiExitApp, Link_name=>"_GuiExitApp__Fs");

procedure   GuiLoadHlpFile;
pragma Import(c,GuiLoadHlpFile, Link_name=>"_GuiLoadHlpFile__Fv");

procedure   GuiSetHlpFile  (p1:string; p2:HMODULE);

procedure   GuiSetMsgFile (p:GuiStr);
pragma Import(c,GuiSetMsgFile, Link_name=>"_GuiSetMsgFile__FPc");

procedure   GuiSaveCmdLine  (p1:integer;p2: pchar);

function GuiCmdLineCnt return  SHORT ;
pragma Import(c,GuiCmdLineCnt, Link_name=>"_GuiCmdLineCnt__Fv");

function   GuiCmdLineArg (p:SHORT) return GuiStr ;
pragma Import(c,GuiCmdLineArg, Link_name=>"_GuiCmdLineArg__Fs");

procedure   GuiBeep (p:SHORT);
pragma Import(c,GuiBeep, Link_name=>"_GuiBeep__Fs");

procedure   GuiSound (p1:LONG; p2:LONG);

function GuiStrTable (p1:LONG; p2:HMODULE) return String ;

function GuiNullMsg return PMESSAGE ;
pragma Import(c,GuiNullMsg, Link_name=>"_GuiNullMsg__Fv");

procedure   GuiSetMsg (p1:PMESSAGE; p2:LONG; p3:ULONG);

function GuiLoadMsg (p:PMESSAGE) return GuiStr;
pragma Import(c,GuiLoadMsg, Link_name=>"_GuiLoadMsg__FP8_MESSAGE");

function GuiShowMsg (p1:PWINDOW; p2:PMESSAGE; p3:string; p4:string)
                     return SHORT;

function  GuiInvokeMsg (p1:PWINDOW; p2:PMESSAGE) return SHORT;
--  Complex Help Function
procedure HelpUsing ;
pragma Import(c,HelpUsing, Link_name=>"_HelpUsing");
procedure HelpMenuInit(Id : SHORT := 23); -- Show Help
pragma Import(c,HelpMenuInit, Link_name=>"_HelpMenuInit");
procedure HelpIndex;
pragma Import(c,HelpIndex, Link_name=>"_HelpIndex");
procedure HelpContents;
pragma Import(c,HelpContents, Link_name=>"_HelpContents");
procedure HelpGeneral; -- Show Help For Help
pragma Import(c,HelpGeneral, Link_name=>"_HelpGeneral");
-----------------------------------------------------------------
procedure   GuiShowHelp  (p:SHORT);
pragma Import(c,GuiShowHelp, Link_name=>"_GuiShowHelp__Fs");

procedure   GuiShowHelpContents   ;
pragma Import(c,GuiShowHelpContents, Link_name=>"_GuiShowHelpContents__Fv");

procedure   GuiShowHelpIndex      ;
pragma Import(c,GuiShowHelpIndex, Link_name=>"_GuiShowHelpIndex__Fv");

procedure   GuiShowHelpForHelp    ;
pragma Import(c,GuiShowHelpForHelp, Link_name=>"_GuiShowHelpForHelp__Fv");

function  GuiRunProgram (p1:string; p2:string;p3: LONG) return LONG ;

function GuiWaitProgram (p1:LONG; p2:SHORT) return LONG ;

function  GuiRandom (p1:LONG;p2:LONG) return LONG ;

procedure   GuiSeed (p:LONG);
pragma Import(c,GuiSeed, Link_name=>"_GuiSeed__Fl");

function GuiError (p1:LONG;p2:LONG;p3:string) return BOOL;

procedure   GuiDebug (p:pchar);
pragma Import(c,GuiDebug, Link_name=>"_GuiDebug__FPce");

procedure   GuiDebugMsg (p1:pchar;p2: ULONG;p3:PMPARAM;p4: PMPARAM);

procedure   GuiInitWindows (p:PAPPINFO);
pragma Import(c,GuiInitWindows, Link_name=>"_GuiInitWindows__FP8_APPINFO");

procedure   GuiExitWindows    ;
pragma Import(c,GuiExitWindows, Link_name=>"_GuiExitWindows__Fv");

function  GuiDesktopWindow return    PWINDOW ;
pragma Import(c,GuiDesktopWindow, Link_name=>"_GuiDesktopWindow__Fv");

function  GuiObjectWindow  return    PWINDOW ;
pragma Import(c,GuiObjectWindow, Link_name=>"_GuiObjectWindow__Fv");

function  GuiNullWindow    return    PWINDOW ;
pragma Import(c,GuiNullWindow, Link_name=>"_GuiNullWindow__Fv");

function GuiMsgFilter (p1:HAB; p2:PQMSG; p3:USHORT) return BOOL;

procedure   GuiFillBackground (p1:HWND; p2:HPS);

function  GuiGetPresRGB (p1:HWND; p2:ULONG; p3:ULONG; p4:LONG) return LONG  ;

procedure   GuiGetClientRect (p1:PWINDOW; p2:PLONG; p3:PLONG; p4:PLONG; p5:PLONG);

procedure   GuiSetMousePtr  (p1:HWND; p2:HPOINTER);

procedure   GuiSetCapture  (p:PWINDOW);
pragma Import(c,GuiSetCapture, Link_name=>"_GuiSetCapture__FP7_WINDOW");

function  GuiInvokeWindow (p1:PWINDOW; p2:PWINDOW) return SHORT  ;

function  GuiLoadWindow (p1:PWINDOW; p2:PWINDOW) return BOOL  ;

function  GuiUnloadWindow (p:PWINDOW) return BOOL  ;
pragma Import(c,GuiUnloadWindow, Link_name=>"_GuiUnloadWindow__FP7_WINDOW");

function GuiProcessWindow  (p:PWINDOW) return SHORT   ;
pragma Import(c,GuiProcessWindow, Link_name=>"_GuiProcessWindow__FP7_WINDOW");

procedure   GuiDismissWindow      (p1:PWINDOW; p2:SHORT);

procedure   GuiActivateWindow     (p:PWINDOW);
pragma Import(c,GuiActivateWindow, Link_name=>"_GuiActivateWindow__FP7_WINDOW");

procedure   GuiGiveFocusWindow    (p:PWINDOW);
pragma Import(c,GuiGiveFocusWindow, Link_name=>"_GuiGiveFocusWindow__FP7_WINDOW");

procedure   GuiMaximizeWindow     (p:PWINDOW);
pragma Import(c,GuiMaximizeWindow, Link_name=>"_GuiMaximizeWindow__FP7_WINDOW");

procedure   GuiMinimizeWindow     (p:PWINDOW);
pragma Import(c,GuiMinimizeWindow, Link_name=>"_GuiMinimizeWindow__FP7_WINDOW");

procedure   GuiRestoreWindow      (p:PWINDOW);
pragma Import(c,GuiRestoreWindow, Link_name=>"_GuiRestoreWindow__FP7_WINDOW");

procedure   GuiGetWindow          (p1:PWINDOW;p2: HWND);

procedure   GuiSetWindow  (p1:PWINDOW;p2: LONG;p3: string;p4: PFNWP;p5: HMODULE);
function  GuiLoadMainWindow  (p1: LONG;p2: string;p3: PFNWP;p4: HMODULE) return WINDOW;

procedure   GuiSetControl  (p1:PWINDOW; p2:PWINDOW; p3:LONG; p4:string);

procedure   GuiSetColor    (p1:PWINDOW; p2:LONG; p3:LONG);

function   GuiGetColor  (p1:PWINDOW; p2:LONG) return LONG  ;

procedure   GuiSetFont    (p1:PWINDOW; p2:string);

function GuiGetFont   (p:PWINDOW) return GuiStr; -- String  ;
pragma Import(c,GuiGetFont, Link_name=>"_GuiGetFont__FP7_WINDOW");

function  GuiFontAttrs (p1:string; p2:PFATTRS) return BOOL  ;

function   GuiFontCount return  LONG         ;
pragma Import(c,GuiFontCount, Link_name=>"_GuiFontCount__Fv");

function GuiEnumFonts (p:LONG) return GuiStr  ;
pragma Import(c,GuiEnumFonts, Link_name=>"_GuiEnumFonts__Fl");

function GuiGetShort (p1:PWINDOW; p2:LONG) return SHORT   ;

procedure   GuiSetShort  (p1:PWINDOW; p2:LONG; p3:SHORT);

function  GuiGetLong  (p1:PWINDOW; p2:LONG) return LONG   ;

procedure   GuiSetLong  (p1:PWINDOW; p2:LONG; p3:LONG);

function GuiGetReal (p1:PWINDOW;p2: LONG) return double  ;

procedure   GuiSetReal  (p1:PWINDOW; p2:LONG; p3:REAL);

function GuiGetString  (p1:PWINDOW; p2:LONG) return string  ;

procedure   GuiSetString   (p1:PWINDOW; p2:LONG; p3:string);

function  GuiGetImage  (p1:PWINDOW; p2:LONG) return Image  ;

procedure   GuiSetImage (p1:PWINDOW; p2:LONG; p3:Image);

function  GuiGetPtr  (p1:PWINDOW; p2:LONG) return PVOID  ;

procedure   GuiSetPtr  (p1:PWINDOW; p2:LONG; p3:PVOID);

function  GuiDataIndex (p:HWND) return LONG   ;
pragma Import(c,GuiDataIndex, Link_name=>"_GuiDataIndex__FUl");

function GuiSendMsg (p1:HWND;p2:ULONG;p3:PMPARAM;p4:PMPARAM) return MRESULT ;

procedure   GuiBroadcastMsg (p1:HWND; p2:ULONG; p3:PMPARAM; p4:PMPARAM);

function GuiEventLoop (p:PMPARAM) return BOOL   ;
pragma Import(c,GuiEventLoop, Link_name=>"_GuiEventLoop__FPv");

function GuiTabbing (p1:HWND; p2:ULONG; p3:PMPARAM;p4:PMPARAM) return BOOL   ;

function GuiDefFrameProc (p1:PFNWP; p2:HWND; msg:ULONG;mp1:PMPARAM;mp2:PMPARAM) return Ulong ;

function GuiDefWinProc   (p1:PFNWP; p2:HWND; p3:ULONG;p4:PMPARAM;p5:PMPARAM) return Ulong ;

procedure   GuiRegisterButton     (p:HAB);
pragma Import(c,GuiRegisterButton, Link_name=>"_GuiRegisterButton__FUl");

procedure   GuiRegisterCombobox   (p:HAB);
pragma Import(c,GuiRegisterCombobox, Link_name=>"_GuiRegisterCombobox__FUl");

procedure   GuiRegisterEntry      (p:HAB);
pragma Import(c,GuiRegisterEntry, Link_name=>"_GuiRegisterEntry__FUl");

procedure   GuiRegisterListbox    (p:HAB);
pragma Import(c,GuiRegisterListbox, Link_name=>"_GuiRegisterListbox__FUl");

procedure   GuiRegisterMLE        (p:HAB);
pragma Import(c,GuiRegisterMLE, Link_name=>"_GuiRegisterMLE__FUl");

procedure   GuiRegisterScrollbar  (p:HAB);
pragma Import(c,GuiRegisterScrollbar, Link_name=>"_GuiRegisterScrollbar__FUl");

procedure   GuiRegisterStatic     (p:HAB);
pragma Import(c,GuiRegisterStatic, Link_name=>"_GuiRegisterStatic__FUl");

function  GuiFrameCtlProc       (p1:HWND; p2:ULONG;p3:PMPARAM;p4:PMPARAM) return Ulong;

function  GuiMenuCtlProc        (p1:HWND; p2:ULONG;p3:PMPARAM;p4:PMPARAM) return Ulong;

function  GuiButtonCtlProc      (p1:HWND; p2:ULONG;p3:PMPARAM;p4:PMPARAM) return Ulong;

function  GuiComboboxCtlProc    (p1:HWND; p2:ULONG;p3:PMPARAM;p4:PMPARAM) return Ulong;

function  GuiEntryCtlProc       (p1:HWND; p2:ULONG;p3:PMPARAM;p4:PMPARAM) return Ulong;

function  GuiListboxCtlProc     (p1:HWND; p2:ULONG;p3:PMPARAM;p4:PMPARAM) return Ulong;

function  GuiMLECtlProc         (p1:HWND; p2:ULONG;p3:PMPARAM;p4:PMPARAM) return Ulong;

function  GuiScrollbarCtlProc   (p1:HWND; p2:ULONG;p3:PMPARAM;p4:PMPARAM) return Ulong;

function  GuiStaticCtlProc      (p1:HWND; p2:ULONG;p3:PMPARAM;p4:PMPARAM) return Ulong;

function GuiInsertItem (p1:PWINDOW;p2:SHORT;p3:String) return SHORT   ;

procedure   GuiDeleteItem (p1:PWINDOW; p2:SHORT);

procedure   GuiClearItems  (p:PWINDOW);
pragma Import(c,GuiClearItems, Link_name=>"_GuiClearItems__FP7_WINDOW");

function GuiGetItemText (p1:PWINDOW;p2: SHORT) return String  ;

procedure   GuiSetItemText  (p1:PWINDOW; p2:SHORT; p3:String);

function  GuiGetItemHandle  (p1:PWINDOW; p2:SHORT) return LONG  ;

procedure   GuiSetItemHandle  (p1:PWINDOW; p2:SHORT; p3:LONG);

procedure   GuiSelectItem  (p1:PWINDOW;p2:SHORT; p3:BOOL);

function GuiNextSelection  (p1:PWINDOW; p2:SHORT) return SHORT   ;

function GuiAbs(p:integer) return integer ;
pragma Import(c,GuiAbs,Link_name=>"_GuiAbs__Fi");

function  GuiAbs(p:SHORT) return SHORT  ;
pragma Import(c,GuiAbs,Link_name=>"_GuiAbs__Fs");

function GuiAbs(p:LONG) return LONG  ;
pragma Import(c,GuiAbs, Link_name=>"_GuiAbs__Fl");

-- function GuiAbs (p:SREAL) return SREAL  ;
-- pragma Import(c,GuiAbs, Link_name=>"_GuiAbs");

function GuiAbs (p:REAL) return REAL ;
pragma Import(c,GuiAbs, Link_name=>"_GuiAbs__Fr");

function GuiAbs(p:LREAL) return LREAL  ;
pragma Import(c,GuiAbs,Link_name=>"_GuiAbs__Fd");

function GuiMod (p1:integer; p2:integer) return integer  ;

function GuiMod (p1:SHORT; p2:SHORT) return SHORT  ;

function  GuiMod (p1:LONG;p2: LONG) return LONG   ;

-- function  GuiMod (p1:SREAL;p2:SREAL) return SREAL ;

function  GuiMod (p1:REAL;p2:REAL) return REAL ;

function  GuiMod (p1:LREAL;p2:LREAL) return LREAL ;

function GuiInt    (p:REAL) return REAL  ;
pragma Import(c,GuiInt, Link_name=>"_GuiInt__Fd");

function GuiFrac   (p:REAL) return REAL  ;
pragma Import(c,GuiFrac, Link_name=>"_GuiFrac__Fd");

function GuiExp    (p:REAL) return REAL  ;
pragma Import(c,GuiExp, Link_name=>"_GuiExp__Fd");

function GuiLog    (p:REAL) return REAL  ;
pragma Import(c,GuiLog, Link_name=>"_GuiLog__Fd");

function GuiSqr    (p:REAL) return REAL  ;
pragma Import(c,GuiSqr, Link_name=>"_GuiSqr__Fd");

function GuiPow    (p1:REAL;p2:REAL) return REAL ;
pragma Import(c,GuiPow, Link_name=>"_GuiPow__FdT1");

function GuiFloor  (p:REAL) return REAL  ;
pragma Import(c,GuiFloor, Link_name=>"_GuiFloor__Fd");

function GuiCeil   (p:REAL) return REAL  ;
pragma Import(c,GuiCeil, Link_name=>"_GuiCeil__Fd");

function GuiSin    (p:REAL) return REAL  ;
pragma Import(c,GuiSin, Link_name=>"_GuiSin__Fd");

function GuiCos    (p:REAL) return REAL  ;
pragma Import(c,GuiCos, Link_name=>"_GuiCos__Fd");

function GuiTan    (p:REAL) return REAL  ;
pragma Import(c,GuiTan, Link_name=>"_GuiTan__Fd");

function GuiASin   (p:REAL) return REAL  ;
pragma Import(c,GuiASin, Link_name=>"_GuiASin__Fd");

function GuiACos   (p:REAL) return REAL  ;
pragma Import(c,GuiACos, Link_name=>"_GuiACos__Fd");

function GuiATan   (p:REAL) return REAL  ;
pragma Import(c,GuiATan, Link_name=>"_GuiATan__Fd");

function GuiPI     return REAL ;
pragma Import(c,GuiPi, Link_name=>"_GuiPi__Fv");

function GuiDeg    (p:REAL) return REAL  ;
pragma Import(c,GuiDeg, Link_name=>"_GuiDeg__Fd");

function GuiRad    (p:REAL) return REAL  ;
pragma Import(c,GuiRad, Link_name=>"_GuiRad__Fd");

function  GuiGetPS (p:PWINDOW) return LONG   ;
pragma Import(c,GuiGetPS, Link_name=>"_GuiGetPS__FP7_WINDOW");

procedure   GuiReleasePS          (p:LONG);
pragma Import(c,GuiReleasePS, Link_name=>"_GuiReleasePS__Fl");

procedure   GuiClearPS            (p:LONG);
pragma Import(c,GuiClearPS, Link_name=>"_GuiClearPS__Fl");

procedure   GuiMoveTo (p1:LONG;p2:LONG;p3:LONG);

procedure   GuiLineTo (p1:LONG;p2:LONG;p3:LONG);

procedure   GuiDrawLine (p1:LONG;p2:LONG;p3:LONG;p4:LONG;p5:LONG);

procedure   GuiDrawBox  (p1:LONG;p2:LONG;p3:LONG;p4:LONG;p5:BOOL);

procedure   GuiDrawCircle (p1:LONG;p2:LONG;p3:BOOL);

procedure   GuiDrawEllipse (p1:LONG;p2:LONG;p3:LONG;p4:BOOL);

procedure   GuiDrawText (p1:LONG;p2: string);

procedure   GuiDrawImage  (p1:LONG;p2:Image;p3:LONG);

procedure   GuiSetDrawColor (p1:LONG;p2:LONG);

function  GuiGetDrawColor (p:LONG) return LONG   ;
pragma Import(c,GuiGetDrawColor, Link_name=>"_GuiGetDrawColor__FI");

procedure   GuiSetBackColor  (p1:LONG;p2:LONG);

function  GuiGetBackColor (p:LONG) return LONG   ;
pragma Import(c,GuiGetBackColor, Link_name=>"_GuiGetBackColor__Fl");

procedure   GuiSetSysColor  (p1:LONG;p2:LONG);

function  GuiGetSysColor (p:LONG) return LONG    ;
pragma Import(c,GuiGetSysColor, Link_name=>"_GuiGetSysColor__Fl");

procedure  GuiSetLineType (p1:LONG;p2:LONG);

function  GuiGetLineType (p:LONG) return LONG  ;
pragma Import(c,GuiGetLineType, Link_name=>"_GuiGetLineType__Fl");

procedure   GuiSetFillPattern     (p1:LONG;p2:LONG);

function  GuiGetFillPattern (p:LONG) return LONG   ;
pragma Import(c,GuiGetFillPattern, Link_name=>"_GuiGetFillPattern__Fl");

-- DLL support
function GuiRecordDLL (p1:PFNVOID;p2: PFNVOID) return BOOL   ;

procedure   GuiInitDLLs           ;
pragma Import(c,GuiInitDLLs, Link_name=>"_GuiInitDLLs__Fv");

procedure   GuiExitDLLs           ;
pragma Import(c,GuiExitDLLs, Link_name=>"_GuiExitDLLs__Fv");

function GuiForever return SHORT ;
pragma Import(c,GuiForever, Link_name=>"_GuiForever__Fv");

function GuiVal(s:string) return Long;

function SHORT1FROMMP(p:System.address) return SHORT ;
pragma Import(c,SHORT1FROMMP, Link_name=>"_FromMP1");

function SHORT2FROMMP(p:System.address) return SHORT ;
pragma Import(c,SHORT2FROMMP, Link_name=>"_FromMP2");

function MPFROMSHORT(p:Short) return MPARAM;
pragma Import(c,MPFROMSHORT, Link_name=>"_MPFromShort");

function UlongFromUshortUshort(l:ushort;h:ushort) return Ulong;
pragma Import(c,UlongFromUshortUshort, Link_name=>"_UlongFromUshortUshort");

function UshortFromUshortUshort(l:ushort;h:ushort) return Ushort;
pragma Import(c,UshortFromUshortUshort, Link_name=>"_UshortFromUshortUshort");

function GuiHelpSetUp(papp: PAPPINFO;Panel_Id:Ulong) return HELPINIT ;
procedure GuiAddEntry(papp:APPINFO;wMainFrame:WINDOW) ;
function GuiInvokeApplication(
 ApplicationName:string  ; -- Name of application
 Title          :string  ; -- Title of main Window
 WindowClass    :string  ; -- Name of Window Class
 IDD_MAINFRAME  :LONG    ; -- Number of resurce connected with Window
 pwMainFrame    :PWINDOW ; -- Main Application Window pointer
 DialogWndProc  :PFNWP   ) -- Name of Dialog Function
                         return PAPPINFO;

function GuiInvokeDialogWindow(
 Title            :string  ; -- Title of dialog Window
 WindowClass      :string  ; -- Name of Window Class
 IDD_DIALOGFRAME  :LONG    ; -- Number of resurce connected with Window
 pwParentFrame    :PWINDOW ; -- Main Application Window pointer
 pwDialogFrame    :PWINDOW ; -- Main Application Window pointer
 DialogWndProc    :PFNWP   ) -- Name of Dialog Function
                         return APIRET  ;

function  GuiStrLower (s:string ) return string ;
function  GuiStrUpper (s:string ) return string ;
function  GuiStrLeft (s:string; size: integer) return string ;
function  GuiStrMid (s:string; start, size: integer) return string;
function  GuiStrRight (s:string; size: integer) return string ;
function  GuiStrTrim (s:string ) return string ;
function  GuiStrLTrim (s:string ) return string ;
function  GuiStrRTrim (s:string ) return string ;
function  GuiStrRepeat (char:character; repeat:integer ) return string;
function  GuiStrSearch (s:string; sub:string; start: integer)return integer ;
function  GuiStrFill (s:string; size:integer; filler:string)return string ;
function  GuiToString (p:pvoid; size:integer) return string;
procedure StaticText(pwin:PWINDOW;TXT:string;IDD_EVENT:Long ) ;
function GuiSetDrawField(pwin:PWINDOW;resurce:LONG;backcolor:LONG) return  LONG;
Pragma Import(c,GuiSetDrawField,Link_Name=>"_SetDrawField");

function GuiSetField(pwin:PWINDOW;resurce:LONG;backcolor:LONG) return  LONG;
Pragma Import(c,GuiSetField,Link_Name=>"_SetField");

function GuiPostMsg(pwin:PWINDOW;msg: Ulong;mp1,mp2:MPARAM ) return  BOOL;
Pragma Import(c,GuiPostMsg,Link_Name=>"_GuiPostMsg");
end Os2.Jba;
